package lab10;

import java.util.Comparator;



public class myExtendedBinaryTree<E> implements ExtendedBinaryTree<E> {
	private BTNode<E> root; // reference to the root

	private Comparator<E> comparator;
	
	/** Creates an empty binary tree. */
	public myExtendedBinaryTree(  /** ?? **/ ) {
		root = null; // start with an empty tree

        /** ?? **/
	}

	/** Returns whether the tree is empty. */
	@Override
	public boolean isEmpty() {
		return (root == null);
	}

	/*
	 * Fill all the methods declared in BinaryTree.java plus any method you
	 * consider necessary
	 */

	@Override
	/** Insert an element to the tree */
	public boolean insert(E e) {
		if ( root == null ) {
			root = new BTNode<E> (e, null, null, null);
			return true;
		}
		return insert(root, e);
	}

	/**
	 * 
	 * @param start
	 * @param e
	 * @return
	 */
	private boolean insert (BTNode<E> start, E e) {
		int result=0; //= /** ?? **/

		if( result == 0 ) //duplicate
			return false;
		
		if( result < 0 ) {
			if(start.getLeft() == null) { //insert here
				
				BTNode<E> to_add = new BTNode<E>(e, start, null, null);
				start.setLeft(to_add);
				return true;
			}
			else
				return insert(start.getLeft(), e);
		}
		else {
			if(start.getRight() == null) { //insert here
				
				BTNode<E> to_add = new BTNode<E>(e, start, null, null);
				start.setRight(to_add);
				return true;
			}
			else
				return insert(start.getRight(), e);
		}
	}

	@Override
	/** Search a specific element */
	public boolean contains(E e) {
		return search(root, e) != null;
	}
	
	@Override
	/** Search a specific element */
	public E search(E e) {
		BTNode<E> temp = search(root, e);
		if (temp == null)
			return null;
		return temp.element();
	}
	
	/**
	 * 
	 * @param start node to start searching
	 * @param e the element to search for
	 * @return the node containing the element or false
	 */
	private BTNode<E> search(BTNode<E> start, E e) {
		if (start == null)
			return null;
		
		E node_data = start.element();
		int result=0; //= /** ?? **/
		
		if ( result == 0 ) {
			return start;
		}
		
		if ( result > 0)
			return search(start.getLeft(), e);
		else 
			return search(start.getRight(), e);
	}

	/**
	 *
	 * @param start
	 * @return the leaf with the maximum value under start
	 */
	private BTNode<E> getMaxLeaf(BTNode<E> start) {
		if(start == null)
			return null;
	
		if (start.getRight() != null)
			return getMaxLeaf(start.getRight());
		else if (start.getLeft() != null)
			return getMaxLeaf(start.getLeft());
		else
			//is a leaf
			return start;
	}
	
	/** A method that removes an element */
	public boolean remove(E e) {
		
		BTNode<E> temp = search(root, e);
		
		if(temp == null) //not exist
			return false;
		
		//remove temp from the tree
		if(temp.isLeaf()) {
			return temp.getParent().replaceChild(temp, null);
		}
		
		//find replacement node : the max of the left subtree
		BTNode<E> replacement = getMaxLeaf(temp.getLeft());
		
		
		if(replacement == null) {
			//this should happen if left subtree is null and temp is not leaf
			//replace temp with min of right subtree or its right child

			replacement = temp.getRight();
			
			replacement.setParent(temp.getParent());
			temp.getParent().replaceChild(temp,  replacement);
			return true;
		}
		System.out.println("replace "+temp.element() + " with "+replacement.element());
		
		if (temp.getLeft() != replacement) { //to avoid circles
			replacement.setLeft(temp.getLeft());
			replacement.getLeft().setParent(replacement);
		}
		else {
			replacement.setLeft(null);
		}
		if (temp.getRight() != replacement) {
			replacement.setRight(temp.getRight());
			replacement.getRight().setParent(replacement);
		}
		else
			replacement.setRight(null);
		replacement.getParent().replaceChild(replacement, null);
		if (temp == root) {
			System.out.println("Delete root");
			root = replacement;
			replacement.setParent(null);
			return true;
		}
		return temp.getParent().replaceChild(temp, replacement);
	}
	
	@Override
	public String SortedRepresentation() {
		if(root == null) {
			return "Empty Tree";
		}
		return SortedRepresentation(root);
	}

	private String SortedRepresentation(BTNode<E> start) {
		
		if(start == null)
			return "";
		
		
		return 	SortedRepresentation(start.getLeft()) 
				+ start.element() + ","  
				+ SortedRepresentation(start.getRight());
		
	}
	@Override
	public String TreeStructure() {
		return "Root\n"+printStructure(root, "");
	}

	private String printStructure(BTNode<E> node, String offset){

		if(node == null)
			return offset + "|_______" + "null";

		
		return 	offset 
				+ "|_______" + node.element()+"\n" 
				+ printStructure(node.getLeft(), "\t"+offset)
				+ "\n"+offset+"\t|\n"
				+ printStructure(node.getRight(),"\t"+offset) ;
		
	}
		
	@Override
	public int size() {
		return getSize(root);
	}
	
	private int getSize(BTNode<E> start) {
		return (start == null) ? 0 : 1 + getSize(start.getLeft()) + getSize(start.getRight());
	}

	private class BTNode <E>{
		  private E element;  // element stored at this node
		  private BTNode<E> left, right, parent;  // adjacent nodes

		  /** Main constructor */
		  public BTNode(E element, BTNode<E> parent, BTNode<E> left, BTNode<E> right)
		  {
		    setElement(element);
		    setParent(parent);
		    setLeft(left);
		    setRight(right);
		  }

		  /** Returns the element stored at this position */
		  public E element() { return element; }

		  /** Sets the element stored at this position */
		  public void setElement(E o) { element=o; }

		  /** Returns the left child of this position */
		  public BTNode<E> getLeft() { return left; }

		  /** Sets the left child of this position */
		  public void setLeft(BTNode<E> v) { left=v; }

		  /** Returns the right child of this position */
		  public BTNode<E> getRight() { return right; }

		  /** Sets the right child of this position */
		  public void setRight(BTNode<E> v) { right=v; }

		  /** Returns the parent of this position */
		  public BTNode<E> getParent() { return parent; }

		  /** Sets the parent of this position */
		  public void setParent(BTNode<E> v) { parent=v; }

		  public boolean isLeaf() { return left == null && right == null; }
		  
		  public boolean replaceChild(BTNode<E> c, BTNode<E> r) { 
			  if (left == c) {
				  left = r;
				  return true;
			  }
			  if(right == c) {
				  right = r;
				  return true;
			  }
			  return false;
		  }
	}
}
